{{
This Hydroponic pump control Object is based on RTC_DEMO.spin ver1.01 by Mathew Brown.
I made made very many changes and additions to Mathew's RTC_DEMO.spin

The end result seems to work very good.
This object controls
              RTC: "RealTimeClock"
              LCD : "FullDuplexSerial"
              Pumps : "PumpControl2-WithPumpsREV2"
FullDuplexSerial controls the Parallax 2 Line LCD display with backlight.
RealTimeClock keeps time very accurately as far as I can tell so far.
PumpControl2-WithPumpsREV2 Controls the output, Turning on my pumps.

}}

CON ''System Parameters

  _CLKMODE = XTAL1 + PLL16X                             {Clock type HS XTAL, + P.L.L. with 16x multiplier}
  _XINFREQ = 5_000_000                                  {Crystal frequency 5.000Mhz}       
  '(16*5Mhz) = 80.000Mhz clock

  _STACK = 1024                                         {reserve 1K of longs for stack... overkill!!}

CON ''Date string return format type constants..

  UkFormat = 0                                          'False (zero)
  UsaFormat = 1                                         'True (non-zero)

  'GG added the following line, copied from other program.
  TxPin = 8   'TXPIN IS PIN #8 ON THE QUICKSTART BOARD.
                                                  
VAR

  
  byte Secs                             'Seconds passed
  word hrset                            'gghours number
  word minset                           'ggminutes number
  word secset                           'ggseconds number
  Long P1hrs, P1mins                    'To be used by PumpControl2-WithpumpsREV2 for hrs.and Minutes. 
  byte flag1
  byte PumpFlagON                       'Used to cycle through LCD pump On\Off only one time
  byte PumpFlagOFF                      'Used to cycle through LCD pump On\Off only one time
  byte pumpFlag2on                      'Used to cycle through LCD makeup pump on/off only one time
  byte pumpFlag2off                     'Used to cycle through LCD makeup pump on/off only one time
OBJ

  RTC: "RealTimeClock"
  LCD : "FullDuplexSerial"
  Pumps : "PumpControl2-WithPumpsREV2"
PUB Main  'Real time clock initial setup
 
  'set up for initial gg preset of the clock by pushing buttons
  '12 Oclock Midnight is written 0hours, 0minutes, 0seconds
  hrset:= 0
  minset:= 0
  secset:= 0
  

' Make pins 11,12 and 15 input
' Pin 15 will allow setting of time, Pin 11 will be hours, pin 12 will be minutes.  Seconds will stay at 0.
dira[11] := 0
dira[12] := 0
dira[15] := 0

' Pin 16 is the buzzer, make it an output and set it low.
'dira[16] := 1
'outa[16] := 0
  

  LCD.start(TxPin, TxPin, %1000, 9_600)  'This is setting for LCD display.

'Set up and display initial clock LCD view.
   
  WaitCnt(ClkFreq / 100 + Cnt)          ' Pause to initialize
  LCD.tx(12)                            ' Clear
  WaitCnt(ClkFreq / 100 + Cnt)          ' Pause so the LCD display has time to clear 
  LCD.tx(17)                            ' Turn on backlight
  LCD.str(String("Time"))               ' First line
  LCD.tx(13)                            ' Line feed
  LCD.tx(212)                           ' Set quarter note
  LCD.tx(220)                           ' A tone             
  LCD.tx(18)                            ' Turn off backlight


  DisplayTime 
                                       
pub DisplayTime                         'Set up and display initial time values               
 'This needs to leave the "Time" text alone.
 'Then clear the space used to display the Time and
 'print the initial values of Time 
 'The repeat needs to drop out when the Pin15 button is pressed.
 'This was originally used in the Motor1 Motor2 speed display.
 
  LCD.TX(134)                    'Move cursor to line 0, position 6
  LCD.Dec(hrset)                 'Print hourset data to LCD display                         
  LCD.TX(137)                    'Move cursor to line0, position 9
  LCD.Dec(minset)                'Print minset data to LCD
  LCD.TX(139)                    ' Move cursor to line 0, position 11
  LCD.TX(22)                     'Turn Display ON, with cursor off and no blink
  waitcnt (30_000_000 + cnt)     'Wait a bit so the LCD display does not update too quickly.
   
  TimeSetting
pub TimeSetting         'if pushbutton is pressed, increase or decrease the hours, minutes and seconds. 
 
  repeat
         Waitpeq (|<15, |<15, 0)                      'Pause program execution until button ina[15] is pressed and held.
                                       

                                             
     If INA[11]==1 and INA[15]==1                     'Holding pushbuttons 11 and 15 should increment the hours
       'increment the hours from 0 thru 24
       hrset:=hrset+1
       if hrset > 23
         hrset:=0
         LCD.TX(134)                                  'Move cursor to line 0, position 6
         LCD.str(String("  "))                        'Clear the two digit hour space
         LCD.TX(134)                                  'move cursor back to line 0, position 6
      DisplayTime
    
    
     If INA[12]==1  and INA[15]==1                   'Holding pushbuttons 12 and 15 should increment the minutes.
       'increment the minutes from 0 thru 60
       minset:=minset+1
        If minset >59
          minset:=0
          LCD.TX(137)                                  'Move cursor to line 0, position 9
          LCD.str(String("   "))                       'Clear the two digit minute space
          LCD.TX(137)                                  'Move cursor back to line0, position9
      DisplayTime

     If INA[15]==0
       quit                
 
  'Start Real time clock
  RTC.Start
                                 
  'Start the Pump Control
  Pumps.Start(@P1hrs, @p1mins)
  'The PumpControl2-WithPumpsREV2.spin needs the start/stop methods set up properly to run in a new cog.
                                                     

  'Preset time/date
  RTC.SetTime (hrset,minset,secset)                     'On startup this will be (0, 0, 0)
  RTC.SetDate(16,9,14)                                  '31,12,07 New years eve, 2007
                                                        'I'm not using the calendar yet.
'-------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------

  LCD.tx(12)                                    'Form Feed, Cursor is moved to position 0 on line 0 and
                                                'LCD display is cleared.
  WaitCnt(ClkFreq * 1 + Cnt)                            
    
  LCD.str(String("Time"))                       'Place Time on the LCD display                

'-------------------------------------------------------------------------------------------------------  
 repeat
  
    'Wait for next second to pass, rather than constantly sending time/date to LCD display
    Secs := RTC.ReadTimeReg(0)                'Read current second
    repeat while Secs == RTC.ReadTimeReg(0)   'Wait until second changes
        p1hrs:=RTC.ReadTimeREG(2)             'Hour data from the RTC To be used 
                                              'in PumpControl2-WithPumpsREV2.spin 
        p1Mins:=RTC.ReadTimeREG(1) '          'Minute data
          LCD.TX(134)                         'Move cursor to line 0, position 6
          LCD.Str(RTC.ReadStrTime)            'Time should display here. 
          
          If ina[23]==0 and PumpFlagOFF == 0   'ina[23] is actually reading status of OUTA[23]       
            PumpFlagON := 0
            PumpFlagOFF :=1
            LCD.TX(18)                          'Turn off LCD BackLight
            LCD.TX(148)                         'Move cursor to line 1, Position0
            LCD.str(String( "               ")) 'Clear all characters from Line1
            LCD.Tx(148)                         'Move cursor back to Line1, Position0
            LCD.str(String( "FeedPump is OFF"))
                                  
          IF ina[23]==1 and PumpFlagON == 0     'ina[23] is actually reading status of OUTA[23] 
            PumpFlagON := 1
            PumpFlagOFF := 0
            LCD.TX (17)                         'Turn on LCD BackLight
            LCD.TX(148)                         'Move cursor to line 1, Position0
            LCD.str(String( "               ")) 'Clear all characters from Line1
            LCD.Tx(148)                         'Move cursor back to Line1, Position0
            LCD.str(String( "FeedPump is ON"))

          If ina[20]==0 and pumpFlag2off == 0   'ina[20] is actually reading status of OUTA[20]       
            PumpFlagON := 0
            pumpFlag2off :=1
            LCD.TX(18)                          'Turn off LCD BackLight
            LCD.TX(148)                         'Move cursor to line 1, Position0
            LCD.str(String( "               ")) 'Clear all characters from Line1
            LCD.Tx(148)                         'Move cursor back to Line1, Position0
            LCD.str(String( "FeedPump is OFF")) 'If the MakeupPump is turned off, 
                                                'then this sets correct LCD display text.

          IF ina[20]==1 and pumpFlag2on == 0    'ina[20] is actually reading status of OUTA[20] 
            pumpFlag2on := 1
            pumpFlag2off := 0
            LCD.TX (17)                         'Turn on LCD BackLight
            LCD.TX(148)                         'Move cursor to line 1, Position0
            LCD.str(String( "                "))'Clear all characters from Line1
            LCD.Tx(148)                         'Move cursor back to Line1, Position0
            LCD.str(String( "MakeupPump is ON"))
                                                    
'-------------------------------------------------------------------------------------------------------
'End of Object Code. 